﻿Imports System.Xml
Imports System.IO

Public Class Class_prognoz

    Dim puth As String 'Путь к запущенному приложению 
    Dim url As String 'Файл на сервере с прогнозом
    Dim Prognoz_file As String 'Файл на клиенте, куда положить прогноз
    Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Integer, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Integer, ByVal lpfnCB As Integer) As Integer
    Public Event ErrorDownload(ByVal FromPathName As String, ByVal ToPathName As String)
    Public Event DownloadComplete(ByVal FromPathName As String, ByVal ToPathName As String)

    Public Sub New()
        'Полный путь к библиотеке
        Dim sFullPuth As String = System.Reflection.Assembly.GetExecutingAssembly().Location
        puth = Left(sFullPuth, sFullPuth.LastIndexOf("\"))
        Prognoz_file = puth & "\Temp\prognoz" & ".xml"
    End Sub

    Public Function DownloadFile(ByVal FromPathName As String, ByVal ToPathName As String, ByVal idTextbox As Integer)
        If URLDownloadToFile(0, FromPathName, ToPathName, 0, 0) = 0 Then
            DownloadFile = True
            RaiseEvent DownloadComplete(FromPathName, ToPathName)
        Else
            DownloadFile = False
            RaiseEvent ErrorDownload(FromPathName, ToPathName)
        End If
    End Function

    Public Function Get_prognoz(ByVal sity As String, ByVal t1 As Boolean, ByVal t2 As Boolean, ByVal t3 As Boolean, ByVal t4 As Boolean) As String
        Dim rezult As String = ""
        Dim datas = Microsoft.VisualBasic.Left(Date.Today.ToString, 10)
        Dim sity_id = Strings.Left(sity, 5)
        url = "http://informer.gismeteo.ru/xml/" & sity_id & "_1.xml"
        Call DownloadFile(url, Prognoz_file, 3)
        'Расшифровать полученный файл

        Try
            Dim xml_doc As New XmlDocument
            xml_doc.Load(Prognoz_file)

            Dim PROGNOZ As String() = New String(3) {} '4 прогноза 
            Dim xmlnodelist As XmlNodeList = xml_doc.GetElementsByTagName("FORECAST")
            For i As Integer = 0 To xmlnodelist.Count - 1
                Dim xmlChildnodelist As XmlNodeList = xmlnodelist(i).ChildNodes

                Dim day As String = xmlnodelist(i).Attributes.GetNamedItem("day").Value
                Dim month As String = xmlnodelist(i).Attributes.GetNamedItem("month").Value
                Dim year As String = xmlnodelist(i).Attributes.GetNamedItem("year").Value
                Dim hour As String = xmlnodelist(i).Attributes.GetNamedItem("hour").Value
                Dim tod As String = xmlnodelist(i).Attributes.GetNamedItem("tod").Value
                Dim predict As String = xmlnodelist(i).Attributes.GetNamedItem("predict").Value
                Dim weekday As String = xmlnodelist(i).Attributes.GetNamedItem("weekday").Value

                Dim PHENOMENA_cloudiness As String = xmlChildnodelist.Item(0).Attributes.GetNamedItem("cloudiness").Value
                Dim PHENOMENA_precipitation As String = xmlChildnodelist.Item(0).Attributes.GetNamedItem("precipitation").Value
                Dim PHENOMENA_rpower As String = xmlChildnodelist.Item(0).Attributes.GetNamedItem("rpower").Value
                Dim PHENOMENA_spower As String = xmlChildnodelist.Item(0).Attributes.GetNamedItem("spower").Value

                Dim PRESSURE_min As String = xmlChildnodelist.Item(1).Attributes.GetNamedItem("min").Value
                Dim PRESSURE_max As String = xmlChildnodelist.Item(1).Attributes.GetNamedItem("max").Value

                Dim TEMPERATURE_min As String = xmlChildnodelist.Item(2).Attributes.GetNamedItem("min").Value
                Dim TEMPERATURE_max As String = xmlChildnodelist.Item(2).Attributes.GetNamedItem("max").Value

                Dim WIND_min As String = xmlChildnodelist.Item(3).Attributes.GetNamedItem("min").Value
                Dim WIND_max As String = xmlChildnodelist.Item(3).Attributes.GetNamedItem("max").Value
                Dim WIND_direction As String = xmlChildnodelist.Item(3).Attributes.GetNamedItem("direction").Value

                Dim RELWET_min As String = xmlChildnodelist.Item(4).Attributes.GetNamedItem("min").Value
                Dim RELWET_max As String = xmlChildnodelist.Item(4).Attributes.GetNamedItem("max").Value

                Dim HEAT_min As String = xmlChildnodelist.Item(5).Attributes.GetNamedItem("min").Value
                Dim HEAT_max As String = xmlChildnodelist.Item(5).Attributes.GetNamedItem("max").Value

                '_________________________________Формируем строку с прогнозом____________________________________

                'город дата и время, на которое составлен прогноз в данном блоке
                PROGNOZ(i) = "В городе " & Strings.Right(sity, sity.Length - 6) & " " & day & "." & month & "." & year & " в " & hour & " час. прогнозируется: "

                'температура воздуха, в градусах Цельсия 
                PROGNOZ(i) = PROGNOZ(i) & " температура " & TEMPERATURE_min & " - " & TEMPERATURE_max & " гр. Цельсия "

                'атмосферное давление, в мм.рт.ст. 
                PROGNOZ(i) = PROGNOZ(i) & " давление " & PRESSURE_min & " - " & PRESSURE_max & " мм.рт.ст., "

                'облачность по градациям:  0 - ясно, 1- малооблачно, 2 - облачно, 3 - пасмурно 
                Select Case PHENOMENA_cloudiness
                    Case 0
                        PROGNOZ(i) = PROGNOZ(i) & "ясно, "
                    Case 1
                        PROGNOZ(i) = PROGNOZ(i) & "малооблачно, "
                    Case 2
                        PROGNOZ(i) = PROGNOZ(i) & "облачно, "
                    Case 3
                        PROGNOZ(i) = PROGNOZ(i) & "пасмурно, "
                End Select

                'тип осадков: 4 - дождь, 5 - ливень, 6,7 – снег, 8 - гроза, 9 - нет данных, 10 - без осадков
                Select Case PHENOMENA_precipitation
                    Case 4
                        PROGNOZ(i) = PROGNOZ(i) & "дождь, "
                    Case 5
                        PROGNOZ(i) = PROGNOZ(i) & "ливень, "
                    Case 6
                        PROGNOZ(i) = PROGNOZ(i) & "снег, "
                    Case 7
                        PROGNOZ(i) = PROGNOZ(i) & "снег, "
                    Case 8
                        PROGNOZ(i) = PROGNOZ(i) & "гроза, "
                    Case 10
                        PROGNOZ(i) = PROGNOZ(i) & "без осадков, "
                End Select

                'интенсивность осадков, если они есть. 0 - возможен дождь/снег, 1 - дождь/снег
                Select Case PHENOMENA_rpower
                    Case 0
                        PROGNOZ(i) = PROGNOZ(i) & "возможен дождь/снег, "
                    Case 1
                        PROGNOZ(i) = PROGNOZ(i) & "дождь/снег, "
                End Select

                'вероятность грозы, если прогнозируется: 0 - возможна гроза, 1 - гроза 
                Select Case PHENOMENA_spower
                    Case 0
                        PROGNOZ(i) = PROGNOZ(i) & "возможна гроза, "
                    Case 1
                        PROGNOZ(i) = PROGNOZ(i) & "гроза, "
                End Select

                'относительная влажность воздуха, в % 
                PROGNOZ(i) = PROGNOZ(i) & "относительная влажность воздуха " & RELWET_min & " - " & RELWET_max & " %, "

                ' направление ветра в румбах, 0 - северный, 1 - северо-восточный,  и т.д. 
                Select Case WIND_direction
                    Case 0
                        PROGNOZ(i) = PROGNOZ(i) & "ветер северный, "
                    Case 1
                        PROGNOZ(i) = PROGNOZ(i) & "ветер северо-восточный, "
                    Case 2
                        PROGNOZ(i) = PROGNOZ(i) & "ветер восточный, "
                    Case 3
                        PROGNOZ(i) = PROGNOZ(i) & "ветер юго-восточный, "
                    Case 4
                        PROGNOZ(i) = PROGNOZ(i) & "ветер южный, "
                    Case 5
                        PROGNOZ(i) = PROGNOZ(i) & "ветер юго-западный, "
                    Case 6
                        PROGNOZ(i) = PROGNOZ(i) & "ветер западный, "
                    Case 7
                        PROGNOZ(i) = PROGNOZ(i) & "ветер северо-западный, "
                End Select

                ' минимальное и максимальное значения средней скорости ветра, без порывов 
                PROGNOZ(i) = PROGNOZ(i) & "средняя скорость ветра " & WIND_min & " - " & WIND_max & " м/сек. "

                ' комфорт - температура воздуха по ощущению одетого по сезону человека, выходящего на улицу
                'PROGNOZ(i) = PROGNOZ(i) & "комфорт " & HEAT_min & " - " & HEAT_max & " . "
            Next

            rezult = ""
            If t1 = True Then
                rezult = rezult + PROGNOZ(0)
            End If
            If t2 = True Then
                rezult = rezult + PROGNOZ(1)
            End If
            If t3 = True Then
                rezult = rezult + PROGNOZ(2)
            End If
            If t4 = True Then
                rezult = rezult + PROGNOZ(3)
            End If

            If rezult = "" Then
                rezult = "А что вы хотите увидеть? Ничего не выбрано :) "
            End If
        Catch ex As Exception
            rezult = "Ошибка при расшифровке файла."
        Finally
            'Удалить полученный файл
            If File.Exists(Prognoz_file) = True Then File.Delete(Prognoz_file)
            Get_prognoz = rezult
        End Try

    End Function

#Region "Opisanie"
    '    Описание формата:

    'TOWN информация о пункте прогнозирования: 
    '  index уникальный пятизначный код города 
    '  sname закодированное название города 
    '  latitude широта в целых градусах 
    ' longitude долгота в целых градусах 
    'FORECAST информация о сроке прогнозирования: 
    '  day, month, year дата, на которую составлен прогноз в данном блоке 
    '  hour местное время, на которое составлен прогноз 
    '  tod время суток, для которого составлен прогноз: 0 - ночь 1 - утро, 2 - день, 3 - вечер 
    '  weekday день недели, 1 - воскресенье, 2 - понедельник, и т.д. 
    '  predict заблаговременность прогноза в часах 
    'PHENOMENA  атмосферные явления: 
    '  cloudiness облачность по градациям:  0 - ясно, 1- малооблачно, 2 - облачно, 3 - пасмурно 
    '  precipitation тип осадков: 4 - дождь, 5 - ливень, 6,7 – снег, 8 - гроза, 9 - нет данных, 10 - без осадков 
    '  rpower интенсивность осадков, если они есть. 0 - возможен дождь/снег, 1 - дождь/снег 
    '  spower вероятность грозы, если прогнозируется: 0 - возможна гроза, 1 - гроза 
    'PRESSURE атмосферное давление, в мм.рт.ст. 
    'TEMPERATURE температура воздуха, в градусах Цельсия 
    'WIND приземный ветер 
    '  min, max минимальное и максимальное значения средней скорости ветра, без порывов 
    '  direction  направление ветра в румбах, 0 - северный, 1 - северо-восточный,  и т.д. 
    'RELWET относительная влажность воздуха, в % 
    'HEAT комфорт - температура воздуха по ощущению одетого по сезону человека, выходящего на улицу 

#End Region

End Class
